moAnimals = {};
source(MultiOverlayV3.modDir.."scripte/module/animals/moAnimalsConfig.lua");

function moAnimals:update(dt)
	if moModule.active.animals.isRunning then
		if moAnimals.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateAnimals"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moAnimals.values.updateTimer, name="updateAnimals", ms=moAnimals.values.msec, repeatable=1, action=moAnimals.loadAnimals} )
		else
			moAnimals:loadAnimals();
		end;
	end;
end;

function moAnimals:loadAnimals()
	moModule.active.animals.isRunning = true;moModule.active.animals.last = moModule.time.min+moModule.time.delay;
	moAnimals:setGetAnimals();
end;

function moAnimals:setGetAnimals()
	local playerFarmId = g_currentMission.player.farmId;
	moAnimals.values.animals = {}; --new 
	if moModule.animals ~= nil and #moModule.animals > 0 then
		local deleteObject = {};
		for index=1, #moModule.animals do
			if moModule.animals[index] ~= nil then
				local isObject = moModule:isObject(moModule.animals[index].object);
				if isObject then
					local animal = moModule.animals[index].object;
					if animal.ownerFarmId == 0 or animal.ownerFarmId == playerFarmId then
						local animalModule = animal:getModuleByName("animals");
						if animalModule ~= nil then		
							local animalName = moModule.animals[index].xmlName; --tostring(animalModule:getAnimalType());--:lower());
							if moAnimals.values.animals[animalName] == nil then moAnimals.values.animals[animalName] = {};end;
							moAnimals.values.animals[animalName][#moAnimals.values.animals[animalName]+1] = {general={},output={},input={}};
							----
							local lineTableGeneral = moAnimals.values.animals[animalName][#moAnimals.values.animals[animalName]].general;
							lineTableGeneral[#lineTableGeneral+1] = {};
							local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];
							isLineTableGeneral.object = animal;							
							isLineTableGeneral.objectName = moModule.animals[index].name;
							isLineTableGeneral.xmlName = animalName;
							local animalNameTemp = tostring(animalModule:getAnimalType());
							isLineTableGeneral.animalName = moLanguageXml:getTxt(animalNameTemp:lower(), nil, animalNameTemp);
							isLineTableGeneral.numAnimals = Utils.getNoNil(animalModule:getNumOfAnimals(), 0);							
							isLineTableGeneral.productivity = g_i18n:formatNumber(Utils.getNoNil(animal.globalProductionFactor, 0)*100);
							isLineTableGeneral.productivityName = moLanguageXml:getTxt("productivity", nil, g_i18n:getText("statistic_productivity"));
							isLineTableGeneral.productivityColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(animal.globalProductionFactor, 0)*100, true}, "getProzentColor Productivity ".. tostring(animalName:upper()));
							local foodSpillageModule = animal:getModuleByName("foodSpillage");
							if foodSpillageModule ~= nil and foodSpillageModule.hasCleanliness then
								isLineTableGeneral.cleanLiness = g_i18n:formatNumber(Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100);
								isLineTableGeneral.cleanLinessName = moLanguageXml:getTxt("cleanliness", nil, g_i18n:getText("statistic_cleanliness"));
								isLineTableGeneral.cleanLinessColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100, true}, "getProzentColor Cleanliness ".. tostring(animalName:upper()));
							end;
							----
							if animalName ~= "dog" and animalModule.reproductionRatesPerDay ~= nil then					
								local reproductionTimePerDay = 0;
								for fillType, rates in pairs(animalModule.reproductionRatesPerDay) do					
									if rates > 0 then
										reproductionTimePerDay = animalModule:getReproductionTimePerDay(fillType);
										break;							
									end;
								end;
								reproductionTimePerDay = g_i18n:formatMinutes(reproductionTimePerDay);
								isLineTableGeneral.reproductionTimePerDay = reproductionTimePerDay;	
								isLineTableGeneral.reproductionTimePerDayName = moLanguageXml:getTxt("reproductionrate", nil, g_i18n:getText("statistic_reproductionRate"));								
							end;
							
							----
							local lineTableOutput = moAnimals.values.animals[animalName][#moAnimals.values.animals[animalName]].output;
							local palletsProduction = animal:getPalletsFilltypeInfo();
							if palletsProduction ~= nil and palletsProduction ~= AnimalHusbandry.NO_FILLTYPE_INFOS then
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];
								local palletsModule = animal:getModuleByName("pallets");																								
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevelsPal(palletsModule);
								local palFull, palNotFull = moItems:getOwnItemsPal(fillTypesTotal[1], palletsModule, 6); --not mp
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];
								if fillType ~= nil then 
									isLineTableOutput.fillTypeName = fillType.name.. " ".. moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));
									isLineTableOutput.fillTypeRegName = fillType.regName;
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));
									
								end;								
								--palletFillUnitIndex
								--palletFillTypeIndex								
								isLineTableOutput.fillTypesTotal = fillTypesTotal;								
								--local palFull, palNotFull = moAnimals:getFillTypePal(palletsModule);								 
								isLineTableOutput.palFull = palFull; --g_i18n:formatNumber(Utils.getNoNil(palletsModule:getCurrentPalletFillLevel(), 0)); --palletsModule.numObjectsInPalletSpawnerTrigger;
								isLineTableOutput.palNotFull = palNotFull;
								--isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(palletsModule.fillLevels[palletsModule.palletFillUnitIndex], 0));
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0)); --string.format("%1.1f", "".. Utils.getNoNil(palletsModule.palletSpawnerFillDelta, 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));								
							end;
							local milkProduction = animal:getMilkFilltypeInfo();
							if milkProduction ~= nil and milkProduction ~= AnimalHusbandry.NO_FILLTYPE_INFOS then
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevels(milkProduction);								
								local fillTypes = moFillTypes.values.fillTypes[fillTypesTotal[1]];
								if fillTypes ~= nil then
									isLineTableOutput.fillTypeName = fillTypes.name;
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("milk", nil, g_i18n:getText("statistic_milkStorage"));
								end;								
								isLineTableOutput.fillTypesTotal = fillTypesTotal;
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));								
							end;
							local liquidManureProduction = animal:getLiquidManureFilltypeInfo();
							if liquidManureProduction ~= nil and liquidManureProduction ~= AnimalHusbandry.NO_FILLTYPE_INFOS then
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevels(liquidManureProduction);
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];								
								if fillType ~= nil then 
									isLineTableOutput.fillTypeName = fillType.name;
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("liquidmanure", nil, g_i18n:getText("statistic_liquidManureStorage"));
								end;
								isLineTableOutput.fillTypesTotal = fillTypesTotal;
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
							end;
							local manureProduction = animal:getManureFilltypeInfo();
							if manureProduction ~= nil and manureProduction ~= AnimalHusbandry.NO_FILLTYPE_INFOS then
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevels(manureProduction);
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];								
								if fillType ~= nil then 
									isLineTableOutput.fillTypeName = fillType.name;
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("manure", nil, g_i18n:getText("statistic_manureStorage"));
								end;
								isLineTableOutput.fillTypesTotal = fillTypesTotal;
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevel/capacity));
							end;
							----
							local lineTableInput = moAnimals.values.animals[animalName][#moAnimals.values.animals[animalName]].input;
							local waterModule = animal:getModuleByName("water");
							if waterModule ~= nil then --and waterModule:hasWater() then
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevels(waterModule:getFilltypeInfos());
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];								
								if fillType ~= nil then
									isLineTableInput.fillTypeName = fillType.name;
								else
									isLineTableInput.fillTypeName = moLanguageXml:getTxt("water", nil, g_i18n:getText("statistic_water"));									
								end;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity)); --g_i18n:formatNumber(Utils.getNoNil(fillLevel/capacity, 0)*100);
							end;
							local strawModule = animal:getModuleByName("straw");
							if strawModule ~= nil then --and strawModule:hasStraw() then
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];
								local capacity, fillLevel, fillTypesTotal = moAnimals:getFillTypeLevels(strawModule:getFilltypeInfos());
								local fillType = moFillTypes.values.fillTypes[fillTypesTotal[1]];								
								if fillType ~= nil then
									isLineTableInput.fillTypeName = fillType.name;
								else
									isLineTableInput.fillTypeName = moLanguageXml:getTxt("straw", nil, g_i18n:getText("statistic_strawStorage"));
								end;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
								isLineTableInput.percentageCapacity = math.floor(100 * (fillLevel/capacity)); --g_i18n:formatNumber(Utils.getNoNil(fillLevel/capacity, 0)*100);
							end;							
							local foodModule = animal:getModuleByName("food");
							if foodModule ~= nil then
								local foodModuleTotal = foodModule:getFilltypeInfos();								
								if foodModuleTotal ~= nil and type(foodModuleTotal) == "table" and #foodModuleTotal > 0 then
									for _, foodGroupTable in pairs(foodModuleTotal) do							
										if foodGroupTable ~= nil then
											lineTableInput[#lineTableInput+1] = {};
											local isLineTableInput = lineTableInput[#lineTableInput];
											isLineTableInput.fillTypeName = "";
											isLineTableInput.fillTypesTotal = {};
											isLineTableInput.capacity = 0;
											isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(foodGroupTable.fillLevel, 0));
											if isLineTableInput.capacity == 0 then 
												isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(foodGroupTable.capacity, 0));
											end;
											--isLineTableInput.percentageCapacity = g_i18n:formatNumber(Utils.getNoNil(foodGroupTable.fillLevel/foodGroupTable.capacity, 0)*100);
											isLineTableInput.percentageCapacity = math.floor(100 * (foodGroupTable.fillLevel/foodGroupTable.capacity));
											if foodGroupTable.foodGroup ~= nil and foodGroupTable.foodGroup.fillTypes ~= nil then
												isLineTableInput.fillTypeName = Utils.getNoNil(foodGroupTable.foodGroup.title, "Unknown");
												for _, fillType in pairs(foodGroupTable.foodGroup.fillTypes) do
													table.insert(isLineTableInput.fillTypesTotal, fillType);
												end;
												if #isLineTableInput.fillTypesTotal == 1 then
													local fillTypes = moFillTypes.values.fillTypes[isLineTableInput.fillTypesTotal[1]];
													if fillTypes ~= nil then
														isLineTableInput.fillTypeName = fillTypes.name;
													else
														isLineTableInput.fillTypeName = moLanguageXml:getTxt("fillcontainer", nil, "Fillcontainer");
													end;
												end;
												if #isLineTableInput.fillTypesTotal > 1 then
													if isLineTableInput.fillTypeName == "Unknown" or string.find(isLineTableInput.fillTypeName, "$l10n_fillTypeGroup") then --MaisPlus Forage Extension
														local fillTypes = moFillTypes.values.fillTypes[isLineTableInput.fillTypesTotal[1]];
														if fillTypes ~= nil then
															isLineTableInput.fillTypeName = fillTypes.name;
														else
															isLineTableInput.fillTypeName = moLanguageXml:getTxt("fillcontainer", nil, "Fillcontainer");
														end;
													end;
												end;
											end;
										end;
									end;
								end;
							end;
							----
						end;
					end;
				else	
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.animals, index);
			end;
			moModule:slotOutputCmd(true);
		end;		
	end;			
end;

function moAnimals:getFillTypePal(palletsModule)
	local maxDistance = 4;
	local palFull = 0;
	local palNotFull = 0;
	local x0,y0,z0 = localToWorld(palletsModule.palletSpawnerNode, 0.5 * palletsModule.palletSpawnerAreaSizeX, 0, 0.5 * palletsModule.palletSpawnerAreaSizeZ); --getWorldTranslation(palletsModule.palletSpawnerNode);
	local result = moAnimals:getMapItems()
	if result ~= nil and palletsModule.palletFillTypeIndex ~= nil and result[palletsModule.palletFillTypeIndex] ~= nil then	
		for _, index in pairs (result[palletsModule.palletFillTypeIndex]) do			
			if index.x ~= nil and index.y ~= nil and index.z ~= nil then				
				local distance = MathUtil.vector3Length(index.x-x0, index.y-y0, index.z-z0);
				if distance < maxDistance then 
					if index.fillLevel == index.capacity then
						palFull = palFull+1;
					elseif index.fillLevel > 0.0 and index.fillLevel < index.capacity then
						palNotFull = palNotFull+1;
					end;
				end;
			end;
		end;		
	end;	
	return palFull, palNotFull;
end;

function moAnimals:getMapItems()
	local result = {};
	for key, value in pairs (g_currentMission.ownedItems) do
		if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
			for _, item in pairs(value.items) do				
				if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then
					if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
						local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
						--if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
							local x0,y0,z0 = getWorldTranslation(item.rootNode);
							if result[fillType] == nil then result[fillType] = {};end;
							result[fillType][#result[fillType]+1] = {amount=1,fillLevel=item.spec_fillUnit.fillUnits[1].fillLevel,capacity=item.spec_fillUnit.fillUnits[1].capacity,x=x0,y=y0,z=z0};							
						--end;
					end;							
				end;
			end;
		end;
	end;
	return result;
end;

function moAnimals:getFillTypeLevelsPal(palletsModule) --WOLLE
	local fillLevelTotal = Utils.getNoNil(palletsModule.fillLevels[palletsModule.palletFillUnitIndex], 0);
	local fillTypesTotal = {};
	local capacityTotal = Utils.getNoNil(palletsModule.fillCapacity, 0);	
	table.insert(fillTypesTotal, palletsModule.palletFillTypeIndex);	
	return capacityTotal, fillLevelTotal, fillTypesTotal;
end;

function moAnimals:getFillTypeLevels(fillTypeModule)
	local fillLevelTotal = 0;
	local fillTypesTotal = {};
	local capacityTotal = 0;
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then
		for _, fillType in pairs(fillTypeModule) do
			fillLevelTotal = fillLevelTotal+fillType.fillLevel;
			capacityTotal = capacityTotal+fillType.capacity;
			table.insert(fillTypesTotal, fillType);
		end;
	end;
	return capacityTotal, fillLevelTotal, fillTypesTotal;
end;