solarcollectoren = {};

--needs solarcollectoren (no update)
--lineType 2/solarcollectoren
function solarcollectoren:load(solarcollectorName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moModule.solarcollectoren ~= nil and #moModule.solarcollectoren > 0 then
		local deleteObject = {};
		for index=1, #moModule.solarcollectoren do		
			if moModule.solarcollectoren[index] ~= nil then
				local solarcollector = moModule.solarcollectoren[index];			
				local isObject = moModule:isObject(solarcollector.object)
				if isObject and (solarcollector.object.ownerFarmId == 0 or solarcollector.object.ownerFarmId == playerFarmId) then
					if solarcollector.xmlName == solarcollectorName then
						lineTable[#lineTable+1] = {};
						local isLineTable = lineTable[#lineTable];			
						isLineTable.ownValues = {solarcollectorName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].nodeId = solarcollector.object.nodeId;
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
						isLineTable.txt[1].bold = true;					
						local isNearObject = moModule:nearPlayerPosition(solarcollector.object, 30);				
						if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = solarcollector.returnClickObjectName;end;	
						if isNearObject ~= nil and isNearObject then
							isLineTable.txt[1].txt = ">>".. solarcollector.name.. "<<";
						else
							isLineTable.txt[1].txt = solarcollector.name;
						end;
						isLineTable.txt[1].txtPos = 1;					
						---
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];			
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 70;	--width prozent	
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("ages", nil, "Age");
						---
						isLineTable.txt[2] = {};
						isLineTable.txt[2].width = 30;	--width prozent	
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = tostring(solarcollector.object.age).. " ".. moLanguageXml:getTxt("ageday", nil, "Day(s)");
						---
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];			
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 70;	--width prozent	
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("incomeperhour", nil, g_i18n:getText("shop_income"));
						---
						isLineTable.txt[2] = {};
						isLineTable.txt[2].width = 30;	--width prozent	
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = g_i18n:formatMoney(solarcollector.object.incomePerHour); --moLanguageXml:getTxt("moneysymbol", nil, "€");	
					end;
				else	
					table.insert(deleteObject, index);				
				end;		
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.solarcollectoren, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;	
	solarcollectoren[solarcollectorName] = {output=lineTable};	
end;

function solarcollectoren.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local solarcollectorName = args.ownValues[1];
			if solarcollector[solarcollectorName] ~= nil and solarcollector[solarcollectorName].output ~= nil and solarcollector[solarcollectorName].output[args.line] ~= nil then
				local nodeId = solarcollectoren[solarcollectorName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;			
		end;		
	end;
end;

function solarcollectoren.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		--moModule.active.solarcollectoren.isRunning = true;moModule.active.solarcollectoren.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local solarcollectorName = args.ownValues[1];
			solarcollectoren:load(solarcollectorName);
			return solarcollectoren[solarcollectorName].output;
		end;
	end;		
end;

function solarcollectoren.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--solarcollectoren:load();	
end;

function solarcollectoren:generateCmd(solarcollectorName)
	local _, errorTable = 0, {};
	function insertCmd(solarcollectorName)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local solarcollectorNameTemp = tostring(solarcollectorName):lower();
		local languageName = moLanguageXml:getTxt(solarcollectorNameTemp, nil, solarcollectorName);
		newCmdTable.cmdTable[1] = {
			cmdName = "solarcollectoren_".. tostring(solarcollectorName);
			displayName = moLanguageXml:getTxt("solarcollectoren", nil, "Solarcollectoren").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Solarcollectoren";
			infoTxt = "Zeigt alle Solarcollectoren oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View Solarcollectoren or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = solarcollectoren.giveOutputTable; --a function
			ownValues = {solarcollectorName}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate solarcollectoren Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if solarcollectorName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "solarcollectoren_".. solarcollectorName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(solarcollectorName);end;
	else
		if moModule.solarcollectoren ~= nil and #moModule.solarcollectoren > 0 then
			for index=1, #moModule.solarcollectoren do
				local solarcollectorName = moModule.solarcollectoren[index].xmlName;
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "solarcollectoren_".. solarcollectorName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(solarcollectorName);end;
			end;			
		end;
	end;
end;

